#include <stdio.h>
#include <string.h>
#include <ldbm.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

static void my_lock(int fd)
{
    lockf(fd,F_LOCK,0L);
}

static void my_unlock(int fd)
{
    lockf(fd,F_ULOCK,0L);
}

int main(int argc,char *argv[])
{
    LDBM
        dbp;

    char
        buf[BUFSIZ];

    Datum
        key_data,
        data_data;

    int
        fd;

    char
        *lock_file="test.lck",
        *db_file="locktest.db";
    srand(time(NULL) ^ getpid());

    /*
    dbp=ldbm_open(db_file,LDBM_WRCREAT|GDBM_NOLOCK,00600,0);
    */
    dbp=ldbm_open(db_file,LDBM_WRCREAT,00600,0);
    if (dbp == NULL)
    {
        (void) fprintf(stderr,"Could not open db for writing, errno=%d\n",gdbm_errno);
        (void) fprintf(stderr,"Error: %s\n",gdbm_strerror(gdbm_errno));
        return(1);
    }
    /*
    fd=gdbm_fdesc(dbp);
    */
    /*
    fd=open(lock_file,O_RDWR|O_CREAT,0600);
    if (fd < 0)
    {
        perror("open");
        return(1);
    }
    */
    ldbm_datum_init(key_data);
    ldbm_datum_init(data_data);


    (void) sprintf(buf,"%d",rand());

    key_data.dptr=buf;
    key_data.dsize=strlen(buf);
    data_data.dptr=buf;
    data_data.dsize=strlen(buf);

    (void) fprintf(stderr,"Storing: %s\n",buf);
    /*
    my_lock(fd);
    */

    if (ldbm_store(dbp,key_data,data_data,LDBM_REPLACE) != 0)
    {
        (void) fprintf(stderr,"Could not store data for %s\n",buf);
    }
    /*
    my_unlock(fd);
    */

    ldbm_close(dbp);

    /* fetch */

    /*
    dbp=ldbm_open(db_file,LDBM_READER|GDBM_NOLOCK,00600,0);
    */

    dbp=ldbm_open(db_file,LDBM_READER,00600,0);
    if (dbp == NULL)
    {
        (void) fprintf(stderr,"Could not open db for reading,(%s)\n",
                       gdbm_strerror(gdbm_errno));
        return(1);
    }

    /*
    fd=gdbm_fdesc(dbp);
    */
    ldbm_datum_init(key_data);
    ldbm_datum_init(data_data);

    key_data.dptr=buf;
    key_data.dsize=strlen(buf);

    /*
    my_lock(fd);
    */
    data_data=ldbm_fetch(dbp,key_data);
    /*
    my_unlock(fd);
    */
    if (data_data.dptr == NULL)
    {
        (void) fprintf(stderr,"XXX Could not find: %s\n",buf);
    }
    else
    {
        memset(buf,0,sizeof(buf));
        memcpy(buf,data_data.dptr,data_data.dsize);
        (void) fprintf(stderr," Found: %s\n\n",buf);
        ldbm_datum_free(dbp,data_data);
    }

    ldbm_close(dbp);
    close(fd);

    return(0);
}

/*
set DB_DIR env var
cc -g -I. -DLDBM_USE_GDBM -o testlock -I$DB_DIR testlock.c libldbm.a -L$DB_DIR/.libs -lgdbm
*/
